\chapter{ZoomBA Syntax in 3 Minutes}\label{intro-ZoomBA}

{\LARGE W}ith some understanding on  any of C,C++, Java, Kotlin, Scala, Python or JavaScript then it will be very easy for you to learn ZoomBA. The biggest syntactic difference between ZoomBA and other languages is that the ';' statement end character is optional. When we consider a ZoomBA program it can be defined as a collection of objects that communicate via invoking each others methods.


\begin{section}{Building Blocks}

\begin{subsection}{Identifiers \& Reserved Keywords}
\index{identifiers}
ZoomBA is case-sensitive, which means identifier Hello and hello would have different meaning.
All ZoomBA components require names. Names used for objects, classes, variables and methods are called identifiers.
A keyword cannot be used as an identifier and identifiers are case-sensitive. 
\begin{enumerate} \index{reserved words}
\item{ Fully Reserved : you can not use these identifiers as variables. 
    \begin{center}
    if, else, for, while, where, size, empty, def, isa , null, type
    \end{center}
}
\item{ Partially Reserved : you should not use these as variables. 
    \begin{center}
    atomic, xml, thread, system, lines, list, dict, 
    type , println, read, send, random, hash , minmax, fold, index, rindex,
    int, float, INT, FOAT, bool, num, str.
    \end{center}  
}
\item{ Specially Reserved : you should not use these as variables. 
    \begin{center}
    @,\$, anything with `\_\_'.
    \end{center}   
}
\end{enumerate}

\end{subsection}


\begin{subsection}{Assignments}
\index{assignment}
Most basic syntax of ZoomBA is, like any other language : assignment.
\begin{center}\begin{minipage}{\linewidth}
\begin{lstlisting}[style=zmbStyle]
 a = 1 //  assigns local variable a to Integer 1
 b = 1.0 //assigns local variable a to b float 1.0
 c = 'Hello, ZoomBA' // assigns local variable c to String 'Hello, ZoomBA'
 d = "Hello, ZoomBA" // same, strings are either single or double quoted
 /* 
 assigns the *then* value of a to e, 
 subsequent change in a wont reflect in e 
 */
 e = a 
\end{lstlisting}
\end{minipage}\end{center}
\end{subsection}

\begin{subsection}{Comments}
\index{comments}

See from the previous subsection "//" used as line comments.
Along with the multiline comment "/*" with  "*/" :

\begin{center}\begin{minipage}{\linewidth}
\begin{lstlisting}[style=zmbStyle]
// this is line comment 
/* this is multiline 
 comment, for large and long lines! 
*/
\end{lstlisting}
\end{minipage}\end{center}


\end{subsection}


\begin{subsection}{Basic Types}

Basic types are :
\begin{center}\begin{minipage}{\linewidth}
\begin{lstlisting}[style=zmbStyle]
 a = 1 // Integer 
 c = 'Hello, ZoomBA' // String
 d = 1.0 // Double 
 l = 1l // long integer 
 L = 1L // Large Integer  
 D = 1.0D // Large Floating   
 tt = true // boolean 
 tf = false // boolean 
 null_literal = null // special null type
\end{lstlisting}
\end{minipage}\end{center}

\end{subsection}

\begin{subsection}{Multiple Assignment}
ZoomBA supports multiple assignment. It has various usage:

\begin{lstlisting}[style=zmbStyle]
 a = 1 // Integer 
 b = 1.0 //  float 
 c = 'Hello, ZoomBA' // String
 // instead, do this straight :
 #(a,b,c ) = [ 1 , 1.0 , 'Hello, ZoomBA' ]
\end{lstlisting}
\end{subsection}
\end{section}

\begin{section}{operators}
\index{operators}


\begin{subsection}{Arithmetic}
\index{operators : Arithmetic}

\begin{center}\begin{minipage}{\linewidth}
\begin{lstlisting}[style=zmbStyle]
a = 1 + 1 // addition : a <- 2
z = 1 - 1 // subtraction : z <- 0
m = 2 * 3 // multiply : m <- 6
d = 3.0 / 2.0 // divide d <- 1.5   
x = 2 ** 10 // Exponentiation x <- 1024
y = -x // negation, y <- -1024 
r = 3 % 2 // modulo, r <- 1 
a += 1 // increment and assign 
z -= 1 // decrement and assign 
x *= 2 // multiply and assign 
y /= 3 // divide and assign 
a /? b // does a divide b?
2 /? 4 // true 
5 /? 13 // false 
\end{lstlisting}
\end{minipage}\end{center}

\end{subsection}

\begin{subsection}{Logical}
\index{operators : Logical}
\begin{lstlisting}[style=zmbStyle]
o = true || true // true , or operator 
a = true && false // false , and operator 
defined_a = is(a) // true if a is defined, false otherwise
o = (10 != 20 ) // not, true 
o = ! ( 10 = 20 ) // true 
o = (10 == 20) // false
o = ( true ^ false ) // true : xor operator for boolean 
o = ( true ^ true ) // false : xor operator for boolean 

\end{lstlisting}

\end{subsection}


\begin{subsection}{Comparison}
\index{operators : Comparison}
\begin{lstlisting}[style=zmbStyle]
t = 10 < 20 // true, less than
f = 10 > 20 // false, greater then 
t = 10 <= 10 // true, less than or equal to 
t = 10 >= 10 // true, greater then or equal to 
t = ( 10 == 10 ) // true, equal to 
f = ( 10 != 10 ) // false, not equal to 
\end{lstlisting}
\end{subsection}

\begin{subsection}{Ternary}
\index{operators : Ternary}
\begin{center}\begin{minipage}{\linewidth}
\begin{lstlisting}[style=zmbStyle]
// basic ternary 
min = a < b ? a : b // general form (expression)?option1:option2 
// try fixing null with it
non_null = a == null? b : a
// or use the null coalescing operator   
non_null = a ?? b 
// same can be used as definition coalescing
defined = is(a) ? a : b
//same as above 
defined = a ?? b
\end{lstlisting}
\end{minipage}
\end{center}
\end{subsection}


\end{section}


\begin{section}{Conditions}
\index{Conditionals}

People coming from any other language would find them trivial.

\begin{subsection}{If}
\index{Conditionals : if}

\begin{lstlisting}[style=zmbStyle]
x = 10 
if ( x < 100 ){
   x = x**2
}
println(x) // printlns back x to standard output : 100
\end{lstlisting}
\end{subsection}

\begin{subsection}{Else}
\index{Conditionals : else}

\begin{lstlisting}[style=zmbStyle]
x = 1000 
if ( x < 100 ){
   x = x**2
}else{
  x = x/10 
}
println(x) // printlns back x to standard output : 100
\end{lstlisting}
\end{subsection}

\begin{subsection}{Else If}
\index{Conditionals : else if}

\begin{center}
\begin{minipage}{\linewidth}
\begin{lstlisting}[style=zmbStyle]
x = 100 
if ( x < 10 ){
   x = x**2
} else if( x > 80  ){
  x = x/10 
} else {
   x = x/100 
}
println(x) // printlns back x to standard output : 10
\end{lstlisting}
\end{minipage}
\end{center}

\end{subsection}

\end{section}

\begin{section}{Loops}
\index{Loops}

\begin{subsection}{While}
\index{Loops : while}

\begin{lstlisting}[style=zmbStyle]
i = 0 
while ( i < 42 ){
  println(i)
  i += 1
}
\end{lstlisting}

\end{subsection}

\begin{subsection}{For}
\index{Loops : for}

For can iterate over any iterable, 
in short, it can iterate over string, any collection of objects,
a list, a dictionary or a range.
That is the first type of for :
\index{Loops : for, range}
\begin{lstlisting}[style=zmbStyle]
for ( i : [0:42] ){ // [a:b] is a range type 
  println(i)
}
\end{lstlisting}
The result is the same as the while loop.
A standard way, from C/C++/Java is to println the same as in :
\index{Loops : for, conditioned}
\begin{lstlisting}[style=zmbStyle]
for ( i = 0 ; i < 42 ; i+= 1  ){ // assignment, condition, after 
  println(i)
}
\end{lstlisting}

There is support for implicit variable for a loop. This variable
is called \$ :

\begin{lstlisting}[style=zmbStyle]
for ( [0:42] ){ // [a:b] is a range type 
  println($)
}
\end{lstlisting}

Just like in Python, we also have a tuple passed as parameter, 
first one being the index, second one being the object in question for the iteration:

\begin{lstlisting}[style=zmbStyle]
for ( idx, obj : [10:13] ){ // [a:b] is a range type 
  printf("Index is %d and Object is %d %n", idx, obj )
}
\end{lstlisting}

Similar way, we have implicit for index, and object :

\begin{lstlisting}[style=zmbStyle]
for ( [10:13] ){ // [a:b] is a range type 
  printf("Index is %d and Object is %d %n", _$, $ )
}
\end{lstlisting}
Scoping rules are simple. \emph{foreach} is effectively a closed function call.
Thus if the iterator variables references are there outside scope, they gets replaced inside, it is hidden.
Once outside the for loop, they can be accessed again.

\end{subsection}
\end{section}

\begin{section}{Functions}
\index{functions}

\begin{subsection}{Defining}
\index{functions : define}

Functions are defined using the $def$ keyword.
And they can be assigned to variables, if one may wish to.
\begin{lstlisting}[style=zmbStyle]
def count_to_num(n){
   for ( i : [0:n] ){
      println(i)
   }
}
// just assign it 
fp = count_to_num
\end{lstlisting}

One can obviously return a value from function :

\begin{lstlisting}[style=zmbStyle]
def say_something(word){
   return ( "Hello " + word ) 
}
\end{lstlisting}

But it is overkill. The last executed statement of a function 
is the return value, thus :

\begin{lstlisting}[style=zmbStyle]
def say_something(word){
    ( "Hello " + word )  // returns it
}
\end{lstlisting}


\end{subsection}

\begin{subsection}{Function Calling}
\index{functions : calling}

Calling a function is trivial :

\begin{lstlisting}[style=zmbStyle]
// calls the function with parameter
count_to_num(42) 
// calls the function at the variable with parameter
fp(42) 
// calls and assigns the return value 
greeting = say_something("Homo Erectus!" ) 
\end{lstlisting}

\end{subsection}

\begin{subsection}{Global Variables}
\index{global variables}
As you would be knowing that the functions create their local scope, 
so if you want to use variables - they must be defined in global scope.
Every external variable is readonly to the local scope, but to println to it, 
use global variables, which starts with \$.   

\begin{lstlisting}[style=zmbStyle]
$a = 0
x = 0 
def use_var(){
   $a = 42 
   println(a) // prints 42 
   println(x) // prints 0, can access global 
   x = 42 
   println(x) // prints 42 
}
// call the method
use_var()
println($a) // global a, prints 42 
println(x) // local x, prints 0 still
\end{lstlisting}
The result would be :
\begin{lstlisting}[style=all]
42
0
42
42
0
\end{lstlisting}
\end{subsection}

\end{section}

\begin{section}{Anonymous Function as a Function Parameter}
\index{functions : anonymous}
A basic idea about what it is can be found \href{https://en.wikipedia.org/wiki/Anonymous\_function}{here}.
As most of the Utility functions use a specific type of anonymous function, 
which is nick-named as "Anonymous Parameter" to a utility function.

\begin{subsection}{Why it is needed?}

Consider a simple problem of creating a list from an existing one, 
by modifying individual elements in some way. This comes under 
\href{https://en.wikipedia.org/wiki/Map\_(higher-order\_function)}{map} , but the idea can be shared much simply:

\begin{lstlisting}[style=zmbStyle]
l = list()
for ( x : [0:n] ){
  l.add ( x * x ) 
}
return l // yep, here... 
\end{lstlisting}
Observe that the block inside the *for loop* takes minimal two parameters, 
in case we println it like this :
\begin{lstlisting}[style=zmbStyle]
// return is not really required, last executed line is return 
def map(x){ x * x } 
l = list()
for ( x : [0:n] ){
  l.add ( map(x) ) 
}
return l // more general  
\end{lstlisting}

Observe now that we can now create another function, lets call it list\_from\_list :

\begin{lstlisting}[style=zmbStyle]
def map(x){ x * x } 
def list_from_list(fp, old_list)
 l = list()
 for ( x : old_list ){
   // use the function *reference* which was passed
   l.add( fp(x) )   
 }
 return l // great...
} 
list_from_list(map,[0:n]) // same as previous 2 implementations
\end{lstlisting}
The same can be achieved in a much sorter way, with this :
\begin{lstlisting}[style=zmbStyle]
list([0:n]) as { $.item * $.item  } 
// if you like short-symbols
list([0:n]) -> { $.o * $.o } 
\end{lstlisting}

The curious block construct after the list function arguments is called anonymous (function) parameter, 
which takes over the map function. The loop stays implicit, and the result is equivalent 
from the other 3 examples. 

This reads as follows :
\emph{create a list from arguments using the block as ...}

The explanation is as follows.
For an anonymous function parameter, there are 3 implicit guaranteed arguments :

\begin{enumerate}
\item{ \$ --> signifies the iteration object. This has the fields : }
\item{ \$.o, \$.item --> Signifies the item of the collection , we call it the $ITEM$ }
\item{ \$.c, \$.context --> The context, or the collection itself , we call it the $CONTEXT$} 
\item{ \$.i, \$.index --> The index of the item in the collection, we call it the $ID$ of iteration } 
\item{ Another case to case parameter is :
     \$.p, \$.partial --> Signifies the partial result of the processing , we call it $PARTIAL$ }
     \index{partial :  \$.p }
\end{enumerate}

The ideas can be simply put into examples by taking this particular case :

\begin{lstlisting}[style=zmbStyle]
l = list([1:5]) as {  
     printf('item : %s , index : %s , partial %s\n', $.o,$.i,$.p) 
 $.o*$.o  } 
\end{lstlisting}
which produces this :

\begin{lstlisting}[style=all]
item : 1 , index : 0 , partial []
item : 2 , index : 1 , partial [1]
item : 3 , index : 2 , partial [1, 4]
item : 4 , index : 3 , partial [1, 4, 9]
\end{lstlisting}

Observe that partial is the partial result of the iteration, 
which would finally yield to the final result. 

\end{subsection}

\begin{subsection}{Some Use Cases}
The data structure section would showcase some use cases. 
But we would use a utility function to showcase the use of this anonymous function.
Suppose there is this function $minmax()$ \index{minmax()} which takes a collection and returns the (min,max) tuple.
In short :

\begin{lstlisting}[style=zmbStyle]
#(min,max) = minmax(1,10,-1,2,4,11)
println(min) // prints -1
println(max) // prints 11    
\end{lstlisting}
But now, suppose we want to find the minimum and maximum by length of a list of strings.
To do so, there has to be a way to pass the comparison done by length.
That is easy :

\begin{lstlisting}[style=zmbStyle]
#(min,max) = minmax( "" , "aa" , "abc" , "aa", "bbbbb" ) as {
             size($.0) < size($.1) }
println(min) // prints empty string 
println(max) // prints bbbbb    
\end{lstlisting}

\end{subsection}

\end{section}

\begin{section}{Available Data Structures}

\begin{subsection}{Range}
\index{range}
A range is basically an iterable, with start and end separated by colon : $[a:b]$.
We already have seen this in action. "a" is inclusive while "b" is exclusive, 
this was designed the standard for loop in mind. There can also be an optional spacing parameter "s",
thus the range type in general is $[a:b:s]$, as described below:

\begin{center}\begin{minipage}{\linewidth}
\begin{lstlisting}[style=zmbStyle]
/* 
  when r = [a:b:s] 
  the equivalent for loop is :
  for ( i = a ; i < b ; i+= s ){
    ... body now ...  
  }
*/
r1 = [0:10] // a range from 0 to 9 with default spacing 1
//a range from 1 to 9 with spacing 2
r2 = [1:10:2] //1,3,5,7,9   
\end{lstlisting}
\end{minipage}\end{center}

\end{subsection}

\begin{subsection}{List}
\index{list()}

To solve the problem of adding and deleting item from an array, list were invented.
\begin{lstlisting}[style=zmbStyle]
fll = [0,1,2,3,4] // fixed length list (not an array, but a list)
fll += 50 // will do nothing, no modification, no error.
l = list ( 0,1,2,3 ) // a list  
l += 10 // now the list is : 0,1,2,3,10
l -= 0 // now the list is : 1,2,3,10
x = l[0] // x is 1 now
l[1] = 100 // now the list is : 1,100,3,10 
\end{lstlisting}

\end{subsection}

\begin{subsection}{Set}
\index{set()}

A set is a collection of elements such that the elements do not repeat.
Thus :

\begin{lstlisting}[style=zmbStyle]
// now the set is : 0,1,2,3
s = set ( 0,1,2,3,1,2,3 ) // a set  
s += 5 // now the set is : 0,1,2,3,5 
s -= 0 // now the set is : 1,2,3
\end{lstlisting}

\begin{subsubsection}{Ordered Set}
\index{set : order }
In Set, elements are not present by their insertion order. To fix that problem, \emph{oset()} exists :
\begin{lstlisting}[style=zmbStyle]
os = oset(12,1,2,3, 10) // if we now print 
println( os ) // you would find them in the same order...
\end{lstlisting}
It is a wrapper over \href{https://docs.oracle.com/javase/9/docs/api/java/util/LinkedHashSet.html}{LinkedHashSet}.

\end{subsubsection}


\begin{subsubsection}{Sorted Set}
\index{set : sorted }
In Set, elements are not sorted by their values. To fix that problem, \emph{sset()} exists :
\begin{lstlisting}[style=zmbStyle]
ss = sset(12,1,2,3, 10) // if we now print 
println( ss ) // you would find them in { 1,2,3,10,12 }
\end{lstlisting}
It is a wrapper over \href{https://docs.oracle.com/javase/9/docs/api/java/util/TreeSet.html}{TreeSet}.

\end{subsubsection}

\end{subsection}

\begin{subsection}{Dict}
\index{dict()}

A dictionary is a collection ( a list of ) (key,value) pairs.
The keys are unique, they are the $keySet()$. Here is how one defines a dict:

\begin{lstlisting}[style=zmbStyle]
d1 = { 'a' : 1 , 'b' : 2 } // a dictionary   
d2 = dict( ['a','b'] , [1,2] ) // same dictionary  
x = d1['a'] // x is 1
x = d1.a // x is 1 
d1.a = 10 // now d1['a'] --> 10 
\end{lstlisting}

\begin{subsubsection}{Ordered Map}
\index{dict : order }
In Map, tuples are not present by their insertion order. To fix that problem, \emph{odict()} exists :
\begin{lstlisting}[style=zmbStyle]
od = odict() //
od[100] = 1 
od[2] = 2 
od[199] = 42  
println( od ) // you would find them in the same order...
\end{lstlisting}
It is a wrapper over \href{https://docs.oracle.com/javase/9/docs/api/java/util/LinkedHashMap.html}{LinkedHashMap}.

\end{subsubsection}


\begin{subsubsection}{Sorted Dict}
\index{dict : sorted }
In Set, elements are not sorted by their keys. To fix that problem, \emph{sdict()} exists :
\begin{lstlisting}[style=zmbStyle]
sd = sdict() 
sd[100] = 1 
sd[10] = 2
sd[-10] = 42 
println( sd ) // you would find them in in sorted key order 
\end{lstlisting}
It is a wrapper over \href{https://docs.oracle.com/javase/9/docs/api/java/util/TreeMap.html}{TreeMap}.

\end{subsubsection}

\end{subsection}

\begin{subsection}{Multi Set}
\index{ multiset }
Many a times, it is necessary to group sets out of a collection. For example, consider the problem of how many
unique integers are there in a collection, along with their frequencies. To solve this, ZoomBA has \emph{mset()} : 

\begin{lstlisting}[style=zmbStyle]
l = [ 1,3,4,3,2,1,1,5]
ms = mset(l) 
{1=3, 2=1, 3=2, 4=1, 5=1} // MultiSet
\end{lstlisting}
What it is depicting is, key 1 has occurred 3 times, 2 occurred once, etc etc
This seats in somewhere between set and a collection, a frequency bucket. 
\emph{mset()} and it's close cousin \emph{group()}  has other usage, 
which we will discuss later when we discuss comprehensions on collections.
\end{subsection}


\begin{subsection}{Mutability}
\index{mutability}

Data structures are not generally mutable in ZoomBA.
What does that mean?
\begin{lstlisting}[style=zmbStyle]
x = [1,2,3]
x + 10 // add some 
println(x) // @[1,2,3] : x did not change
\end{lstlisting}
Thus, a variables value never gets changed, unless someone assigns
back something to it. The only way a variable state can get 
change is through assignment. This is known as \href{https://en.wikipedia.org/wiki/Immutable_object}{Immutability}.
See more of a discussion \href{http://programmers.stackexchange.com/questions/151733/if-immutable-objects-are-good-why-do-people-keep-creating-mutable-objects}{here}.

The mutable additive operators : ``\emph{+=}'' and ``\emph{-=}'' are the ones which do not follow it, because
they are also assignment operators. If the object is part of collection types, they would modify the left hand object itself, 
instead of creating a new instance of the object. Thus :

\begin{lstlisting}[style=zmbStyle]
a = [1,2,3]
a + 10 // creates a new array object  
s = set(1,2,3)
s+= 42 // simply : s.add(42)
s-= 1 // s.remove(1)
s += [2,3,4] // s.addAll( list(2,3,4) )
s-= [3,4] // s.removeAll( list(3,4) )
m = {1:2, 3:4}
m += {5:6} // m.putAll( {5:6} )
m -= 3 // m.remove(3)
\end{lstlisting}

\end{subsection}

\end{section}

